#include "Problem.h"
#include "Solution.h"
#include "tsClass.h"
#include "Control.h"
#include "farthestInsertion.h"


#include <fstream.h>
#include <iostream.h>
#include <math.h>
using namespace std;

int main( int argc, char** argv ) {

  //Create a control object from the command line arguments.
  Control control( argc, argv );
  ostream& out = control.getOutputStream();

  //Create a Random object.
  Random* rnd =  new Random((unsigned) control.getSeed());;


  //Initialize the problem instance, using input file stream and input data given by control.
  Problem *problem = new Problem( control );


  //Run a number of tries, control knows how many tries there should be done
  while( control.triesLeft() ) {
    //Tell control we are starting a new try.
    control.beginTry();    
    
    //Initialize starting solution.
    Solution currentSolution(rnd, control, problem );
    randomizedFarthestInsertion(rnd, currentSolution);
    //    cout << "fi " << currentSolution.computeExpectedCost() << endl;/////

    //    currentSolution.initializeRandomSolution();
    //for(int i=0; i<problem->numberOfCustomers; i++) currentSolution[i] = i;
    //currentSolution.printOn(cout);//////////////
    
    control.setCurrentCost( currentSolution.computeExpectedCost());
    //    currentSolution.printOn(cout); /////////
    //cout << "expectedCost = " << currentSolution.expectedCost << endl;//////////

    //orOpt local search may improve currentSolution.
    tsTspOpt(rnd, control, currentSolution);
    control.endTry();
    currentSolution.printOn(control.getOutputStream());  

    //cout << "after ts " << currentSolution.computeExpectedCost() << endl;/////

    //    currentSolution.printOn(cout);  
  }
  
  /*  //Initialize thresholds vector.
      vector<int> thresholds(problem->numberOfCustomers, -1);
      currentSolution.computeExpectedCostAndThresholds(thresholds);
  */
    

}
